;  Yes, I'm getting better at asm.  This program took me a total of about
;  8 hours.  I need someone to help me understand how to manipulate hl
;  better so I can make arrays.  Then I'll be able to make awesome games!
;  Sorry if there aren't any comments but I don't have enough time. 
;  It takes longer to comment than to code! 
;  Thanks for trying my game and special thanks to the people who release
;  their source code for me to learn from,
;           Matt Teiken
;           2/11/99



#include "asm86.h" 
#include "ti86asm.inc" 
#include ti86abs.inc
_flushallmenus  equ     49DCh   ; clear the 86's menu key stacks
_dispAHL = $4a33
_homeup         equ       4A95h       ; cursror to top left of home screen
.org _asm_exec_ram
;----------------------
	nop
	jp Startup
.dw 0000                 ;Ashell stuff
.dw title
title:
.db "Frog Killer by Matt Teiken",0
;----------------------

Startup:
 call BUSY_OFF
 call _flushallmenus
 call _clrLCD       ;clear screen
  ld hl,TitleScreen
 ld de,$fc00
 call DispRLE				; decode and display the picture
 call pause
 call _clrLCD

;----------Initialize Variables------

 ld a,1
 ld (Hardness),a
 call GetHardness
 call _clrLCD
 call ResetVars
 call ResetTimers

 sbc hl,hl	
 ld (score),hl

 ld hl,(score)
 add hl,hl

 ;sbc hl,hl	
 ;ld (Carshl),hl

 ld a,5
 ld (Carshl),a

 ld a,10
 ld (Misseshl),a

;----------------

 ld de,3762h
 ld hl,(score)
 call SdispHL 

 call LoadCar
 call LoadFrog
 call LoadWall

MainLoop:
 call GetInput

 ld a,$BF
 out (1),a
 nop
 nop
 in a,(1)
 bit 6,a	       ; Check if Exit has been pressed
 jp z,ExitGame

 call MoveFrog
 call TestIntercept
 call WallTest
 
 ld a,(Die)
 cp 1
 jp z,ExitGame

 ld a,(GameSpeed)
 ld b,a
 call Delay
 jp MainLoop

Delay:
 ld a,30
Delay2:
 dec a
 cp 0
 jp z,Delay3
 jp Delay2
Delay3:
 ld a,b
 dec a
 ld b,a
 cp 0
 jp nz,Delay
 ret

MoveFrog:
 ld a,(FrogTimer)
 inc a
 ld (FrogTimer),a
 ld b,a
 ld a,(FrogSpeed)
 cp b
 jp nz,exitpause

 xor a
 ld (FrogTimer),a
 ld a,(FrogMove)
 cp 1
 jp z,ContMoveFrog

 ld a,(FrogTemp)
 inc a
 ld (FrogTemp),a
 cp 30
 jp nz,exitpause
 ld a,1
 ld (FrogMove),a
 xor a
 ld (FrogTemp),a
 jp ContMoveFrog

ContMoveFrog:
 call LoadFrog
 ld a,(fx)
 dec a
 ld (fx),a
 call LoadFrog
 ld a,(fx)
 cp 0
 jp z,FrogMiss
 ret 

FrogMiss:
 call pause
 call LoadFrog
 call LoadCar
 call LoadWall
 xor a
 ld (temp),a
 call ResetVars
 call ResetTimers
 call LoadCar
 call LoadFrog
 call LoadWall
 ld hl,(Misseshl)
 dec hl
 ld (Misseshl),hl
 ld a,(Misses)
 dec a
 ld (Misses),a
 cp 0
 jp z,Die2

 ld de,0600h
 ld hl,(Misseshl)
 call SdispHL
 ret

BurnCar:
 ld a,(temp)
 inc a
 ld (temp),a
 cp 10
 jp z,exitpause
 call Burn1
 ld b,5
 call Delay
 call Burn1
 call Burn2
 ld b,5
 call Delay
 call Burn2
 jp BurnCar

Burn1:
 ld hl,Burned1
 ld a,(cx)
 ld b,a
 ld a,(cy)
 ld c,a
 call PutSprite
 ret

Burn2:
 ld hl,Burned2
 ld a,(cx)
 ld b,a
 ld a,(cy)
 ld c,a
 call PutSprite
 ret

ExitGame:
 call _clrLCD
 jp HighScores

HighScores:
 ld a,(Hardness)
 cp 1
 jp nz,check2

 ld de, 0000h
 ld hl,easytxt
 call DispText

 ld hl,(HighS1)
 call dispHigh
CheckHigh1:
 ld de,(HighS1)
 ld hl,(score)
 call scorechk
 or a
 jp nz,Exit2
 ld (HighS1),hl
	ld hl,varname-1
	rst 20h
	rst 10h
	ld a,b
	ex de,hl
	call _load_ram_ahl
	ld de,HighS1-$d744
	add hl,de
	ld de,(HighS1)
	ld (hl),e
	inc hl
	ld (hl),d
 ld hl,1010h
 ld (_penCol),hl
 ld hl,NHSMsg
 call _vputs
 jp Exit2
check2:
 cp 2
 jp nz,check3

 ld de, 0000h
 ld hl,mediumtxt
 call DispText

 ld hl,(HighS2)
 call dispHigh
CheckHigh2:
 ld de,(HighS2)
 ld hl,(score)
 call scorechk
 or a
 jp nz,Exit2
 ld (HighS2),hl
	ld hl,varname-1
	rst 20h
	rst 10h
	ld a,b
	ex de,hl
	call _load_ram_ahl
	ld de,HighS2-$d744
	add hl,de
	ld de,(HighS2)
	ld (hl),e
	inc hl
	ld (hl),d
 ld hl,1010h
 ld (_penCol),hl
 ld hl,NHSMsg
 call _vputs

 jp Exit2
check3:
 ld de, 0000h
 ld hl,hardtxt
 call DispText

 ld hl,(HighS3)
 call dispHigh
CheckHigh3:
 ld de,(HighS3)
 ld hl,(score)
 call scorechk
 or a
 jp nz,Exit2
 ld (HighS3),hl
	ld hl,varname-1
	rst 20h
	rst 10h
	ld a,b
	ex de,hl
	call _load_ram_ahl
	ld de,HighS3-$d744
	add hl,de
	ld de,(HighS3)
	ld (hl),e
	inc hl
	ld (hl),d
 ld hl,1010h
 ld (_penCol),hl
 ld hl,NHSMsg
 call _vputs

 jp Exit2

Exit2:
 call pause
 call _clrLCD
 call _homeup
 ret

dispHigh:
 ld de,$0610
 push hl
 ld hl,HighScr
 call DispText
 ld de,0634h
 pop hl
 call SdispHL
show_sc:
 ld de, 1810h
 ld hl,scoretxt
 call DispText
 ld de,1825h
 ld hl,(score)
 call SdispHL
 call GET_KEY			; flush keypress buffer
 ret


GetInput:
 ld a,(InputTimer)
 inc a
 ld (InputTimer),a
 ld b,a
 ld a,(InputSpeed)
 cp b
 jp nz,exitpause
 xor a
 ld (InputTimer),a

 ld a,$FE
 out (1),a
 nop
 nop
 in a,(1)
 bit 2,a	      
 jp nz,CheckLeft
 call MoveRight
CheckLeft:
 ld a,$FE
 out (1),a
 nop
 nop
 in a,(1)      
 bit 1,a	      
 jp nz,CheckUp
 call MoveLeft
CheckUp
 ld a,$FE
 out (1),a
 nop
 nop
 in a,(1)
 bit 3,a	      
 jp nz,checkup
 call MoveUp
 jp exitpause
checkup:
 ld a,(CarUp)
 cp 0
 jp z,exitpause
 call MoveUp  
 ret 

MoveUp:
 ld a,(CarUp)
 cp 0
 jp z,Change
 jp Up
Change:
 ld a,1
 ld (CarUp),a
Up:
 call LoadCar
 ld a,(cy)
 dec a
 ld (cy),a
 call LoadCar
 ld a,(cy)
 cp 0
 jp nz,exitpause
 ld a,10
 ld (temp),a
 call Crash
 ret

Crash:
 call LoadCar
 call BurnCar
 call LoadFrog
 call LoadWall
 call ResetVars
 call ResetTimers
 xor a
 ld (FrogMove),a
 ld (FrogTemp),a
 ld hl,(Carshl)
 dec hl
 ld (Carshl),hl
 ld a,(Cars)
 dec a
 ld (Cars),a
 cp 0
 jp z,Die

 ld de,0000h
 ld hl,(Carshl)
 call SdispHL

 call LoadCar
 call LoadFrog
 call LoadWall
 ret

Die:
 ld a,1
 ld (Die),a
 call _clrLCD
 ld de, 0000h
 ld hl,Dietxt
 call DispText
 ld de, 1825h
 ld hl,gameover
 call DispText
 call pause
 ret

Die2:
 ld a,1
 ld (Die),a
 call _clrLCD
 ld de, 0000h
 ld hl,Die2txt
 call DispText
 ld de, 1825h
 ld hl,gameover
 call DispText
 call pause
 ret

ResetVars:
 ld a,56
 ld (cx),a
 ld (cy),a

 ld a,120
 ld (fx),a
 ld a,35
 call random
 inc a
 ld (fy),a

 add a,8
 ld b,a
 ld a,48
 sub b
 call random
 add a,b
 ld (wy),a

 ld a,82
 call random
 inc a
 ld (wx),a

 xor a
 ld (CarUp),a
 ld (FrogMove),a
 ret

MoveLeft:
 ld a,(cx)
 cp 1
 jp z, exitpause
 call LoadCar
 ld a,(cx)
 dec a
 ld (cx),a
 call LoadCar
 ret
MoveRight:
 ld a,(cx)
 cp 90
 jp z, exitpause
 call LoadCar
 ld a,(cx)
 inc a
 ld (cx),a
 call LoadCar      
 ret

TestIntercept:
 ld a,(fx)
 sub 8
 ld c,a
 ld a,(cx)
 cp c
 jp p,ContIntercept
 ld b,a
 xor a
 sub b
ContIntercept:
 jp p, cont2
 jp exitpause
cont2:
 ld a,(fx)
 add a,8
 ld c,a
 ld a,(cx)
 cp c
 jp p,exitpause

 ld a,(fy)
 sub 8
 ld c,a
 ld a,(cy)
 cp c
 jp p,ContIntercept2
 ld b,a
 xor a
 sub b
ContIntercept2:
 jp p, cont3
 jp exitpause
cont3:
 ld a,(fy)
 add a,8
 ld c,a
 ld a,(cy)
 cp c
 jp p,exitpause
 call FrogHit
 ret

WallTest:
 ld a,(wx)
 sub 8
 ld c,a
 ld a,(cx)
 cp c
 jp p,wContIntercept
 ld b,a
 xor a
 sub b
wContIntercept:
 jp p, wcont2
 jp exitpause
wcont2:
 ld a,(wx)
 add a,16
 ld c,a
 ld a,(cx)
 cp c
 jp p,exitpause

 ld a,(wy)
 sub 8
 ld c,a
 ld a,(cy)
 cp c
 jp p,ContwIntercept2
 ld b,a
 xor a
 sub b
ContwIntercept2:
 jp p, contw3
 jp exitpause
contw3:
 ld a,(wy)
 add a,8
 ld c,a
 ld a,(cy)
 cp c
 jp p,exitpause
 ld a,10
 ld (temp),a
 jp Crash
 ret


FrogHit:
 ld hl,(score)
 inc hl
 ld (score),hl
 ld de,3762h
 ld hl,(score)
 call SdispHL 
 call pause
 call LoadFrog
 call LoadWall
 call LoadCar
 call ResetVars
 call ResetTimers
 call LoadCar
 call LoadFrog
 call LoadWall 
 ret

LoadWall:
 ld a,(wx)      ;load x variable into a
 ld b,a         ;. 
 ld a,(wy)      ;load y variable into a
 ld c,a         ;. 
 ld hl,WallPic  ;. 
 call PutSprite ;Put Pic at (c,b)
 ld a,(wx)      ;load x variable into a
 add a,8
 ld b,a         ;. 
 ld a,(wy)      ;load y variable into a
 ld c,a         ;. 
 ld hl,WallPic  ;. 
 call PutSprite ;Put Pic at (c,b)
 ret
 
LoadFrog:
 ld a,(fx)      ;load x variable into a
 ld b,a         ;. 
 ld a,(fy)      ;load y variable into a
 ld c,a         ;. 
 ld hl,FrogPic  ;. 
 call PutSprite ;Put Pic at (c,b)
 ret

LoadCar:
 ld a,(cx)      ;load x variable into a
 ld b,a         ;. 
 ld a,(cy)      ;load y variable into a
 ld c,a         ;. 
 ld hl,CarPic   ;. 
 call PutSprite ;Put Pic at (c,b)
 ret

pause:
    call GET_KEY             ;gets the recent key pressed
    cp K_EXIT                ;compare it to exit
    jr z,exitpause         ;if it's exit, go to TimetoLeave
    cp K_SECOND               ;and similar
    jp z,exitpause
    cp K_ENTER               ;and similar
    jp z,exitpause
    jp pause
exitpause:
    ret

ResetTimers:
 xor a
 ld (FrogTimer),a
 ld (InputTimer),a
 ld (FrogMove),a
 ld (FrogTemp),a
 ld a,(Hardness)
 cp 1
 jp nz,Hard2
 ld a,4
 call random
 add a,11
 ld (FrogSpeed),a
 ld a,9
 ld (InputSpeed),a
 ld a,5 
 ld (GameSpeed),a
 ret
Hard2:
 ld a,(Hardness)
 cp 2
 jp nz,Hard3
 ld a,5
 call random
 add a,7
 ld (FrogSpeed),a
 ld a,7
 ld (InputSpeed),a
 ld a,3
 ld (GameSpeed),a
 ret
Hard3:
 ld a,7
 call random
 add a,4
 ld (FrogSpeed),a
 ld a,5
 ld (InputSpeed),a
 ld a,2
 ld (GameSpeed),a
 ret

GetHardness:
 call _clrLCD
 ld de, 0000h
 ld hl,choosetxt
 call DispText

 ld de, 1015h
 ld hl,easytxt
 call DispText

 ld de, 2015h
 ld hl,mediumtxt
 call DispText

 ld de, 3015h
 ld hl,hardtxt
 call DispText
 
GetHardness2:
 ld a,(Hardness)
 cp 1
 jp nz,hard2
 ld de,1009h
 jp key 
hard2:
 cp 2
 jp nz,hard3
 ld de,2009h
 jp key
hard3:
 ld de,3009h
 jp key
key:
 ld hl,Selector
 call DispText
key2:
 call GET_KEY
 cp K_UP
 jp z,hardup
 cp K_DOWN
 jp z,harddown
 cp K_ENTER
 jp z,exitpause
 cp K_SECOND
 jp z,exitpause
 cp K_EXIT
 jp z,exitpause
 jp key2

hardup:
 ld a,(Hardness)
 cp 1
 jp nz,hardup2
 ld a,3
 ld (Hardness),a
 jp GetHardness
hardup2:
 ld a,(Hardness)
 dec a
 ld (Hardness),a
 jp GetHardness

harddown:
 ld a,(Hardness)
 cp 3
 jp nz,harddown2
 ld a,1
 ld (Hardness),a
 jp GetHardness
harddown2:
 ld a,(Hardness)
 inc a
 ld (Hardness),a
 jp GetHardness


fx:
.db 0

fy:
.db 0

cx:
.db 0

cy:
.db 0

temp:
.db 0

CarUp:
.db 0

FrogMove:
.db 0

FrogTimer:
.db 0
 
FrogSpeed:
.db 0

InputSpeed:
.db 0

InputTimer:
.db 0

FrogTemp:
.db 0

score:
.dw 0

wx:
.db 0
 
wy:
.db 0

Cars:
.db 5

Carshl:
.dw 5

Hardness:
.db 0

GameSpeed:
.db 0

HighS1:
.dw 0

HighS2:
.dw 0

HighS3:
.dw 0 

Misses:
.db 10

Misseshl:
.dw 10

HighScr:	.db "High "
scoretxt:	.db "Score: ",0
NHSMsg:		.db "New High Score!",0
Dietxt:		.db "You crashed all of your cars!",0
Die2txt:    .db "You missed to many frogs!",0
gameover:   .db "| Game Over |",0
choosetxt:  .db "Choose Difficulty",0
easytxt:    .db "EASY",0
mediumtxt:  .db "MEDIUM",0
hardtxt:    .db "HARD",0
Selector:   .db "->",0

random: 	       ; Creates a random number 0 <= x < A
 	push bc
 	push de
 	push hl
 	ld b,a
 	ld a,r
 	add a,a
 	ld hl,0
 	ld d,0
 	ld e,a
RMul:
 	add hl,de
 	djnz RMul
 	ld a,h
 	pop hl
 	pop de
 	pop bc
 	ret

;---------= High Score =---------
; Input: de=previous high score
;	hl=current score
; Output: hl=high score
;	z=1 (a=0) if new high score, z=0 (a=1) if not
; Registers destroyed: af, de, hl
scorechk:
	push	hl
	xor	a
	sbc	hl,de
	pop	hl
	jr	z,nnhs
	jr	nc,nhs
nnhs:	ex	de,hl
	inc	a
nhs:	or	a
	ret

SdispHL:
 		ld (_penCol),de			
		ld de,-1				;routine by Matthew Scepcar
		ld (_curRow),de
		xor a
		call $4a33
		dec hl
		jp _vputs

_clrbuf:
        ld hl,$ca06
        ld de,$ca07
        ld bc,1023
        ld (hl),0
        ldir
        ret

DispText:
 ld (_penCol), de
 call _vputs
 ret
varname:
.db 8,"frogkill"


PutSprite: 
;FastSprite_______________________________
;Input: Sprite in (HL), (b,c)            |
;Output: Sprite xor'ed onto the screen   |
;Destroyed: none                         |
;-----------------------------------------
	push af
	push bc
	push de
	push ix
	push hl
	push hl                 ;\
	pop ix                  ; > hl -> ix
	ld hl, FSByte           ;> point to Tempbyte
	ld (hl), c              ;> put c into Byte for later use
	ld a, b
	rrca                    ;\
	rrca                    ; > divide x by 8 in accumulator
	rrca                    ;/                      
	rld                     ;> Rotate left 4 bytes  
	or $FC                  ;> add a and $FC
	ld l, (hl)              ;\
	ld h, a                 ; > buncha loading going on
	ld a, b                 ;/
	and 7                   ;> mask out the shift number
	ld d, a                 ;> save the shift number
	ld e, 8
FSLoop:                         
	ld a, (ix)              ;> get sprite data
	ld b, a
	inc ix                  ;> point to new sprite data byte
	ld c, 0                 ;> clear c for shift use
	ld a, d                 ;> restore shift # for use
	cp 0
	jp z, NoShift
	ld a, b
	ld b, d
FSShift:
	srl a                   ;\
	rr c                    ; \
	dec b                   ;  > shift until b < 0
	jp z, Shiftend          ; /
	jp FSShift              ;/
NoShift:
	ld a, b
Shiftend:
	xor (hl)                ;> mix the shifted sprite w/screen
	ld (hl), a              ;> and draw it to the screen
	inc hl                  ;> hl points to next screen byte
	ld a, c                 ;> accumulate the remaining shifted data
	xor (hl)                ;> mix 'em
	ld (hl), a              ;> draw it
	ld a, 15                ;\
	add a, l                ; \
	ld l, a                 ;  > Inc the <HL> 1 y value.
	jp nc, FSNoinc          ; /
	inc h                   ;/
FSNoinc:
	dec e                   ; >check if loop is finished
	jp nz, FSLoop           ;/
	pop hl                  ;\
	pop ix                  ; \
	pop de                  ;  > mmmpop boop be doop mmmpop
	pop bc                  ; /  
	pop af                  ;/
	ret
FSByte: 
        .db $00

FrogPic: 
.db %01000001 
.db %00111110 
.db %00111110 
.db %11111110 
.db %11111110 
.db %00111110 
.db %00111110 
.db %01000001

CarPic: 
.db %11000011 
.db %11111111 
.db %11011011 
.db %00011000 
.db %00100100 
.db %11011011 
.db %11111111 
.db %11000011

Burned1: 
.db %00000100 
.db %00100110 
.db %01011010 
.db %01011010 
.db %10010010 
.db %10000001 
.db %00000000 
.db %00000000

Burned2: 
.db %00000100 
.db %00100110 
.db %01111110 
.db %01111110 
.db %11111110 
.db %11111111 
.db %00000000 
.db %00000000

WallPic: 
.db %01111110 
.db %11111111 
.db %11111111 
.db %11111111 
.db %11101110 
.db %11101110 
.db %01001110 
.db %01000100

;===========================================================
; RLE picture displayer v1.1
; Decodes a RLE picture made by RLE2PIC
;
; written by David Phillips <electrum@tfs.net>
; started: 8/19/98
; last update: 11/5/98
;
; input: HL = RLE encoded picture, DE = where to display
; output: 1024 byte decoded picture
; destroys: AF, BC, DE, HL
; current size: 32 bytes
;===========================================================
DispRLE:
 ld bc,1024			; we need to copy 
DispRLEL:
 ld a,(hl)			; get the next byte
 cp $91				; is it a run?
 jr z,DispRLERun	; then we need to decode the run
 ldi				; copy the byte, and update counters
DispRLEC:
 ld a,b				; check the low byte and
 or c				; the high byte for 0
 jr nz,DispRLEL		; if not, then we're not done either
 ret				; if it's zero, we're done
DispRLERun:
 inc hl				; move to the run value
 ld a,(hl)			; get the run value
 inc hl				; move to the run count
 push hl			; save source pointer
 ld h,(hl)			; get the run count
 ex de,hl			; swap source and destination pointers
DispRLERunL:
 ld (hl),a			; copy the byte
 inc hl				; increase destination pointer
 dec bc				; decrease byte count
 dec d				; decrease run count
 jr nz,DispRLERunL	; if we're not done, then loop
 ex de,hl			; swap pointers back
 pop hl				; recover source pointer
 inc hl				; advance the source pointer
 jr DispRLEC		; check to see if we should loop


TitleScreen:


 .db $91,$00,$23,$7f,$ff,$bf,$fc,$00,$1f,$80,$01,$ff
 .db $c0,$91,$00,$06,$37,$19,$9b,$8f,$00,$70,$e0,$07
 .db $07,$c0,$91,$00,$04,$0c,$30,$1e,$0f,$8f,$07,$81
 .db $e0,$78,$1e,$01,$c0,$91,$00,$04,$0f,$f0,$1e,$03
 .db $8f,$03,$c1,$c0,$38,$3c,$00,$e0,$10,$40,$00,$00
 .db $0d,$b0,$1e,$01,$8f,$03,$c3,$c0,$3c,$3c,$00,$60
 .db $0f,$80,$00,$00,$01,$80,$1e,$0c,$0f,$03,$c3,$80
 .db $1c,$78,$00,$00,$0f,$80,$00,$00,$01,$80,$1e,$1c
 .db $0f,$03,$c7,$80,$1e,$78,$00,$00,$3f,$80,$00,$00
 .db $02,$40,$1e,$3c,$0f,$0f,$87,$80,$1e,$78,$00,$00
 .db $3f,$80,$00,$00,$0d,$b0,$1f,$fc,$0f,$ff,$07,$80
 .db $1e,$78,$0f,$f8,$0f,$80,$00,$00,$0f,$f0,$1e,$3c
 .db $0f,$30,$07,$80,$1e,$78,$03,$70,$0f,$80,$00,$00
 .db $0c,$30,$1e,$1c,$0f,$3c,$07,$80,$1e,$78,$01,$e0
 .db $10,$40,$91,$00,$04,$1e,$0c,$0f,$3e,$03,$80,$1c
 .db $38,$01,$e0,$91,$00,$06,$1e,$0c,$0f,$1f,$03,$c0
 .db $3c,$3c,$01,$e0,$91,$00,$06,$1e,$00,$0f,$0f,$01
 .db $c0,$38,$1c,$01,$e0,$91,$00,$06,$1e,$00,$0f,$0d
 .db $81,$e0,$78,$0e,$03,$70,$91,$00,$06,$1e,$00,$1b
 .db $06,$c0,$70,$e0,$07,$87,$c0,$91,$00,$06,$7f,$80
 .db $3f,$c3,$78,$1f,$80,$01,$fc,$91,$00,$0a,$01,$f8
 .db $91,$00,$39,$03,$ff,$ff,$7f,$9f,$e0,$07,$f8,$01
 .db $ff,$fc,$7f,$f8,$91,$00,$03,$01,$b0,$f8,$36,$0d
 .db $80,$03,$60,$00,$dc,$cc,$37,$1e,$91,$00,$04,$f0
 .db $e0,$1e,$07,$80,$01,$e0,$00,$78,$7c,$1e,$0f,$91
 .db $00,$04,$f1,$80,$1e,$07,$80,$01,$e0,$00,$78,$1c
 .db $1e,$07,$80,$91,$00,$03,$f3,$00,$1e,$07,$80,$01
 .db $e0,$00,$78,$0c,$1e,$07,$80,$91,$00,$03,$f6,$00
 .db $1e,$07,$80,$01,$e0,$00,$78,$60,$1e,$07,$80,$91
 .db $00,$03,$fc,$00,$1e,$07,$80,$01,$e0,$00,$78,$e0
 .db $1e,$07,$80,$91,$00,$03,$fe,$00,$1e,$07,$80,$01
 .db $e0,$00,$79,$e0,$1e,$1f,$91,$00,$04,$fb,$00,$1e
 .db $07,$80,$01,$e0,$00,$7f,$60,$1f,$fe,$91,$00,$04
 .db $fd,$80,$1e,$07,$80,$01,$e0,$00,$79,$e0,$1e,$60
 .db $91,$00,$04,$f6,$c0,$1e,$07,$80,$01,$e0,$00,$78
 .db $60,$1e,$78,$91,$00,$04,$f6,$e0,$1e,$07,$80,$31
 .db $e0,$0c,$78,$63,$1e,$7c,$91,$00,$04,$f3,$70,$1e
 .db $07,$80,$61,$e0,$18,$78,$66,$1e,$3e,$91,$00,$04
 .db $f1,$b8,$1e,$07,$80,$e1,$e0,$38,$78,$0e,$1e,$1e
 .db $91,$00,$04,$f0,$dc,$1e,$07,$83,$e1,$e0,$f8,$78
 .db $1e,$1e,$1b,$91,$00,$03,$01,$b0,$c6,$36,$0d,$ce
 .db $e3,$73,$b8,$78,$fc,$36,$0d,$80,$00,$00,$03,$91
 .db $ff,$03,$9f,$ff,$c7,$ff,$f1,$ff,$fc,$7f,$86,$f0
 .db $91,$00,$0e,$03,$f0,$91,$00,$03,$1f,$00,$00,$3b
 .db $80,$00,$07,$e0,$91,$00,$08,$31,$00,$00,$19,$80
 .db $00,$03,$20,$91,$00,$08,$60,$3c,$78,$f9,$f7,$7f
 .db $03,$4f,$bc,$7c,$f9,$ef,$80,$91,$00,$03,$67,$e6
 .db $cd,$99,$9b,$39,$83,$c7,$e6,$d9,$b3,$37,$80,$91
 .db $00,$03,$63,$66,$cd,$99,$99,$5f,$83,$46,$66,$d9
 .db $b3,$f6,$91,$00,$04,$33,$66,$cd,$99,$99,$d8,$03
 .db $06,$66,$70,$e3,$06,$91,$00,$04,$1f,$3c,$78,$fd
 .db $f0,$8f,$87,$8f,$3c,$78,$f1,$ff,$91,$00,$08,$06
 .db $80,$91,$00,$03,$d9,$b0,$91,$00,$09,$07,$91,$00
 .db $04,$f1,$e0,$91,$00,$4d,$0c,$91,$00,$07,$03,$f0
 .db $00,$f3,$c0,$08,$81,$f8,$0d,$c0,$91,$00,$06,$01
 .db $98,$00,$73,$80,$19,$81,$68,$00,$c0,$91,$00,$06
 .db $01,$9b,$b8,$75,$9e,$3f,$e0,$63,$dc,$cd,$ef,$e0
 .db $91,$00,$04,$01,$f1,$90,$5d,$83,$19,$80,$66,$6c
 .db $d3,$36,$60,$91,$00,$04,$01,$98,$a0,$5d,$8f,$19
 .db $80,$67,$ec,$fb,$f6,$60,$91,$00,$04,$01,$98,$e0
 .db $49,$9b,$19,$80,$66,$0c,$db,$06,$60,$91,$00,$04
 .db $03,$f0,$40,$eb,$df,$9f,$e0,$f3,$ff,$ed,$ff,$70
 .db $91,$00,$05,$03,$40,$91,$00,$0e,$03,$80,$91,$00
 .db $0b



.end
